<?php
/* 
fonctions utiles
*/
function isadmin(){
    if(isset($_SESSION['login']) && isset($_SESSION['id'])){
        return true;
    }
    return false;
}

function fix_exists_dir($dir){
    if(!is_dir($dir)){
        mkdir($dir, 0777, true);
    }
}

// permet l'inclusion soit depuis confid, soit depuis app
function getSnippetFile($file){
    if(file_exists(CONFIG."snippets/".$file)){
        return CONFIG."snippets/".$file;
    } else {
        return APP."snippets/".$file;
    }
}

function getContentsFile($file){
    if(file_exists(CONTENTS.$file)){
        return str_replace(CHEMIN,"",CONTENTS.$file);
    } else {
        return str_replace(CHEMIN,"",APP.$file);
    }
}

function getTemplate($file){
    if(file_exists(CONFIG."settings/".$file)){
        return CONFIG."settings/".$file;
    } else {
        return APP."default/".$file;
    }
}

function writehtmlcode($file){
    if(file_exists($file)){
        $p = pathinfo($file);
        switch ($p['extension']){
            case "css":
                echo "<link rel=\"stylesheet\" href=\"".$file."\">\n";
                break;
            case "js":
                echo "<script src=\"".$file."\"></script>\n";
                break;
        }
    }
}

function duplicateFile($source,$dest){
    if(!is_file($source)){
        echo "Le fichier ".$source." n'existe pas, sorry.";
        return false;
    }
    if (!copy($source, $dest)) {
        echo "La copie $source du fichier a échoué...\n";
        return false;
    }
}

/*
déployer l'application: création des dossiers, 
copie des fichiers nécessaires
*/
function deployerAppIfNotYet(){
    $contentht="Options -Indexes";
    if(!is_dir(CHEMIN."contents")){
        $dirs=array(
            "contents", "contents/items", "contents/pages", "contents/sessions", 
            "contents/imports", "contents/cache", "contents/cache/vignettes", "contents/cache/temp", "contents/collections", "upload"
        );
        foreach($dirs as $dir){
            fix_exists_dir(CHEMIN.$dir);
        }
        file_put_contents(CHEMIN."contents/.htaccess",$contentht);
    }

    if(!is_dir(CONTENTS."config")){
        fix_exists_dir(CONFIG."settings");
        fix_exists_dir(CONFIG."access");
        fix_exists_dir(CONFIG."styles");
        fix_exists_dir(CONFIG."favicons");
        fix_exists_dir(CONFIG."snippets");

        // protection en lecture
        file_put_contents(CONFIG.".htaccess",$contentht);
    }
}

function supprimer_cache(){
    @unlink(CACHE."cached-mosaique.html"); 
    //@unlink(CACHE."cached-mosaique-order.yaml");
}

function supprimer_cache_images($image=false){
    if($image){
        $f=pathinfo(basename($image));
        $nom=$f['filename'];
        $images=glob(CACHE_VIGNETTES.$nom."*.{gif,png,jpg,webp}",GLOB_BRACE);
    } else {
        $images=glob(CACHE_VIGNETTES."*.{gif,png,jpg,webp}",GLOB_BRACE);
    }

    foreach($images as $image){
        @unlink($image); 
    }
    // vider le cache pour permettre la recréation des vignettes
    supprimer_cache(); 
}


function makeid($string){
    return strtolower(stripAccents($string));
}

function stripAccents($string){
    $string= \Transliterator::create('NFD; [:Nonspacing Mark:] Remove; NFC')
        ->transliterate($string);
    $string = strtolower(str_replace(array(" ","°","+","=","'",'"',"(",")"),"_",$string));
    return $string;
}

function human_name($str){
    $t=explode(" ",str_replace(array("-","_",'.')," ",$str));
    for($i=0; $i<count($t);$i++){
        $t[$i]=ucfirst($t[$i]);
    }
    return implode(" ",$t);
}
/* bouger le fichier du dossier temp au dossier import si le fichier existe là */
function validateTempfile($file){
    if(file_exists(TEMP.$file)){
        rename(TEMP.$file, IMPORTS.$file);
    }
    return $file;
}

function getcompletefilepath($file, $url=false){
    if(file_exists(IMPORTS.$file) && !$url){ return IMPORTS.$file; }
    if(file_exists(IMPORTS.$file) && $url){ return IMPORTS_URL.$file; }        
    if(file_exists(TEMP.$file) && !$url){ return TEMP.$file; }
    if(file_exists(TEMP.$file) && $url){ return TEMP_URL.$file; }
    return $file;
}

function human_filesize($bytes, $decimals = 2) {
    $factor = floor((strlen($bytes) - 1) / 3);
    if ($factor > 0) $sz = 'KMGT';
    return sprintf("%.{$decimals}f", $bytes / pow(1024, $factor)) . @$sz[$factor - 1] . 'B';
}

function chargerModules(){
    $lmod=glob(CHEMIN."modules/module_*",GLOB_ONLYDIR); // ne prendre que les dossiers qui commencent par "module_"
    $modules=array();
    $catmod=array("insert_admin","insert_pages","insert_item","insert_css","insert_js");
    foreach($catmod as $cat){
        $modules[$cat]=array();
    }
    foreach($lmod as $mod){
        $basemod=str_replace(CHEMIN,"",$mod);
        $configfile=$mod."/modconfig.yaml";
        if(!file_exists($configfile)){
            continue;
        }

        $ar = Spyc::YAMLLoad($configfile);
        foreach($catmod as $cat){
            if(isset($ar[$cat])){
                $modules[$cat][]=$basemod."/".$ar[$cat];
            }
        }
    }
    return $modules;
}